﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
namespace InterpreterDesignPattern
{
    abstract class Expression
    {
        public void Interpret(Context context)
        {
            if (context.Input.Length == 0)
                return;
            int value = 0;
            if (context.Input.StartsWith(Symbol10()))
            {
                value = 10;
                
            }
            else if (context.Input.StartsWith(Symbol11()))
            {
                value = 11;
                
            }
            else if (context.Input.StartsWith(Symbol12()))
            {
                value = 12;
                
            }

            else if (context.Input.StartsWith(Symbol13()))
            {
                value = 13;
                
            }
            else if (context.Input.StartsWith(Symbol14()))
            {
                value = 14;
                
            }
            else if (context.Input.StartsWith(Symbol15()))
            {
                value = 15;
                
            }
            else if (IsSymbolNumberBetween0To9(context.Input.Substring(0, 1)))
            {
                value = int.Parse(context.Input.Substring(0, 1));
            }
            else
            {
                Console.WriteLine("Invalid Hexadecimal Number!");
                context.Output = 0;
                return;
            }

            
            context.Input = context.Input.Substring(1);
            context.Output += (int)(value * Math.Pow(Multiplier() , context.Input.Length ));
            Interpret(context);
        }

        public abstract string Symbol10();
        public abstract string Symbol11();
        public abstract string Symbol12();
        public abstract string Symbol13();
        public abstract string Symbol14();
        public abstract string Symbol15();
        public abstract bool IsSymbolNumberBetween0To9(string num);
        public abstract int Multiplier();
    }
}
